diff --git a/gnome-session/gsm-app.c b/gnome-session/gsm-app.c
index d38138be..c05ae06a 100644
--- a/gnome-session/gsm-app.c
+++ b/gnome-session/gsm-app.c
@@ -21,49 +21,174 @@
 #include "config.h"
 #endif
 
+#include <glib.h>
 #include <string.h>
 
-#include <glib.h>
-#include <gio/gio.h>
-#include <gio/gdesktopappinfo.h>
+#include "gsm-app.h"
+#include "org.gnome.SessionManager.App.h"
 
-#define GNOME_DESKTOP_USE_UNSTABLE_API
-#include <libgnome-desktop/gnome-systemd.h>
+/* If a component crashes twice within a minute, we count that as a fatal error */
+#define _GSM_APP_RESPAWN_RATELIMIT_USEC (60 * G_USEC_PER_SEC)
 
-#include "gsm-app.h"
-#include "gsm-util.h"
+typedef struct
+{
+        char            *id;
+        char            *app_id;
+        int              phase;
+        char            *startup_id;
+        gboolean         registered;
+        gint64           last_restart_time;
+        GDBusConnection *connection;
+        GsmExportedApp  *skeleton;
+} GsmAppPrivate;
 
-#define GSM_APP_SYSTEMD_SKIP_KEY   "X-systemd-skip"
-#define GSM_APP_SYSTEMD_HIDDEN_KEY "X-GNOME-HiddenUnderSystemd"
-#define GSM_APP_ENABLED_KEY        "X-GNOME-Autostart-enabled"
-#define GSM_APP_PHASE_KEY          "X-GNOME-Autostart-Phase"
 
-/* This comment is a record of keys that were previously used but are not used
- * anymore. We keep this so that we don't accidentally redefine these keys in
- * the future, to be used in some incompatible way.
- *
- * X-GNOME-AutoRestart
- * X-GNOME-Autostart-discard-exec
- * AutostartCondition
- * X-GNOME-DBus-Name
- * X-GNOME-DBus-Path
- * X-GNOME-DBus-Start-Arguments
- * X-GNOME-Autostart-startup-id
- * */
-
-struct _GsmApp
-{
-        GObject          parent;
-        GDesktopAppInfo *inner;
+enum {
+        EXITED,
+        DIED,
+        LAST_SIGNAL
 };
 
+static guint32 app_serial = 1;
+
+static guint signals[LAST_SIGNAL] = { 0 };
+
 enum {
         PROP_0,
-        PROP_INNER,
+        PROP_ID,
+        PROP_STARTUP_ID,
+        PROP_PHASE,
+        PROP_REGISTERED,
         LAST_PROP
 };
 
-G_DEFINE_TYPE (GsmApp, gsm_app, G_TYPE_OBJECT)
+G_DEFINE_TYPE_WITH_PRIVATE (GsmApp, gsm_app, G_TYPE_OBJECT)
+
+GQuark
+gsm_app_error_quark (void)
+{
+        static GQuark ret = 0;
+        if (ret == 0) {
+                ret = g_quark_from_static_string ("gsm_app_error");
+        }
+
+        return ret;
+
+}
+
+static gboolean
+gsm_app_get_app_id (GsmExportedApp        *skeleton,
+                    GDBusMethodInvocation *invocation,
+                    GsmApp                *app)
+{
+        const gchar *id;
+
+        id = GSM_APP_GET_CLASS (app)->impl_get_app_id (app);
+        gsm_exported_app_complete_get_app_id (skeleton, invocation, id);
+
+        return TRUE;
+}
+
+static gboolean
+gsm_app_get_startup_id (GsmExportedApp        *skeleton,
+                        GDBusMethodInvocation *invocation,
+                        GsmApp                *app)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+        const gchar *id;
+
+        id = g_strdup (priv->startup_id);
+        gsm_exported_app_complete_get_startup_id (skeleton, invocation, id);
+
+        return TRUE;
+}
+
+static gboolean
+gsm_app_get_phase (GsmExportedApp        *skeleton,
+                   GDBusMethodInvocation *invocation,
+                   GsmApp                *app)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+
+        gsm_exported_app_complete_get_phase (skeleton, invocation, priv->phase);
+        return TRUE;
+}
+
+static guint32
+get_next_app_serial (void)
+{
+        guint32 serial;
+
+        serial = app_serial++;
+
+        if ((gint32)app_serial < 0) {
+                app_serial = 1;
+        }
+
+        return serial;
+}
+
+static gboolean
+register_app (GsmApp *app)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+        GError *error;
+        GsmExportedApp *skeleton;
+
+        error = NULL;
+        priv->connection = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &error);
+        if (error != NULL) {
+                g_critical ("error getting session bus: %s", error->message);
+                g_error_free (error);
+                return FALSE;
+        }
+
+        skeleton = gsm_exported_app_skeleton_new ();
+        priv->skeleton = skeleton;
+        g_dbus_interface_skeleton_export (G_DBUS_INTERFACE_SKELETON (skeleton),
+                                          priv->connection, priv->id,
+                                          &error);
+
+        if (error != NULL) {
+                g_critical ("error registering app on session bus: %s", error->message);
+                g_error_free (error);
+                return FALSE;
+        }
+
+        g_signal_connect (skeleton, "handle-get-app-id",
+                          G_CALLBACK (gsm_app_get_app_id), app);
+        g_signal_connect (skeleton, "handle-get-phase",
+                          G_CALLBACK (gsm_app_get_phase), app);
+        g_signal_connect (skeleton, "handle-get-startup-id",
+                          G_CALLBACK (gsm_app_get_startup_id), app);
+
+        return TRUE;
+}
+
+static GObject *
+gsm_app_constructor (GType                  type,
+                     guint                  n_construct_properties,
+                     GObjectConstructParam *construct_properties)
+{
+        GsmApp    *app;
+        GsmAppPrivate *priv;
+        gboolean   res;
+
+        app = GSM_APP (G_OBJECT_CLASS (gsm_app_parent_class)->constructor (type,
+                                                                           n_construct_properties,
+                                                                           construct_properties));
+        priv = gsm_app_get_instance_private (app);
+
+        g_free (priv->id);
+        priv->id = g_strdup_printf ("/org/gnome/SessionManager/App%u", get_next_app_serial ());
+
+        res = register_app (app);
+        if (! res) {
+                g_warning ("Unable to register app with session bus");
+        }
+
+        return G_OBJECT (app);
+}
 
 static void
 gsm_app_init (GsmApp *app)
@@ -71,13 +196,43 @@ gsm_app_init (GsmApp *app)
 }
 
 static void
-gsm_app_set_inner (GsmApp          *app,
-                   GDesktopAppInfo *app_info)
+gsm_app_set_phase (GsmApp *app,
+                   int     phase)
 {
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+
         g_return_if_fail (GSM_IS_APP (app));
-        g_return_if_fail (app_info == NULL || G_IS_DESKTOP_APP_INFO (app_info));
 
-        g_set_object (&app->inner, app_info);
+        priv->phase = phase;
+}
+
+static void
+gsm_app_set_id (GsmApp     *app,
+                const char *id)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+
+        g_return_if_fail (GSM_IS_APP (app));
+
+        g_free (priv->id);
+
+        priv->id = g_strdup (id);
+        g_object_notify (G_OBJECT (app), "id");
+
+}
+static void
+gsm_app_set_startup_id (GsmApp     *app,
+                        const char *startup_id)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+
+        g_return_if_fail (GSM_IS_APP (app));
+
+        g_free (priv->startup_id);
+
+        priv->startup_id = g_strdup (startup_id);
+        g_object_notify (G_OBJECT (app), "startup-id");
+
 }
 
 static void
@@ -89,8 +244,17 @@ gsm_app_set_property (GObject      *object,
         GsmApp *app = GSM_APP (object);
 
         switch (prop_id) {
-        case PROP_INNER:
-                gsm_app_set_inner (app, g_value_get_object (value));
+        case PROP_STARTUP_ID:
+                gsm_app_set_startup_id (app, g_value_get_string (value));
+                break;
+        case PROP_ID:
+                gsm_app_set_id (app, g_value_get_string (value));
+                break;
+        case PROP_PHASE:
+                gsm_app_set_phase (app, g_value_get_int (value));
+                break;
+        case PROP_REGISTERED:
+                gsm_app_set_registered (app, g_value_get_boolean (value));
                 break;
         default:
                 break;
@@ -104,10 +268,20 @@ gsm_app_get_property (GObject    *object,
                       GParamSpec *pspec)
 {
         GsmApp *app = GSM_APP (object);
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
 
         switch (prop_id) {
-        case PROP_INNER:
-                g_value_set_object (value, app->inner);
+        case PROP_STARTUP_ID:
+                g_value_set_string (value, priv->startup_id);
+                break;
+        case PROP_ID:
+                g_value_set_string (value, priv->id);
+                break;
+        case PROP_PHASE:
+                g_value_set_int (value, priv->phase);
+                break;
+        case PROP_REGISTERED:
+                g_value_set_boolean (value, priv->registered);
                 break;
         default:
                 break;
@@ -118,8 +292,21 @@ static void
 gsm_app_dispose (GObject *object)
 {
         GsmApp *app = GSM_APP (object);
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+
+        g_free (priv->startup_id);
+        priv->startup_id = NULL;
 
-        g_clear_object (&app->inner);
+        g_free (priv->id);
+        priv->id = NULL;
+
+        if (priv->skeleton != NULL) {
+                g_dbus_interface_skeleton_unexport_from_connection (G_DBUS_INTERFACE_SKELETON (priv->skeleton),
+                                                                    priv->connection);
+                g_clear_object (&priv->skeleton);
+        }
+
+        g_clear_object (&priv->connection);
 
         G_OBJECT_CLASS (gsm_app_parent_class)->dispose (object);
 }
@@ -132,22 +319,103 @@ gsm_app_class_init (GsmAppClass *klass)
         object_class->set_property = gsm_app_set_property;
         object_class->get_property = gsm_app_get_property;
         object_class->dispose = gsm_app_dispose;
+        object_class->constructor = gsm_app_constructor;
+
+        klass->impl_start = NULL;
+        klass->impl_get_app_id = NULL;
+        klass->impl_get_autorestart = NULL;
+        klass->impl_provides = NULL;
+        klass->impl_get_provides = NULL;
+        klass->impl_is_running = NULL;
+
+        g_object_class_install_property (object_class,
+                                         PROP_PHASE,
+                                         g_param_spec_int ("phase",
+                                                           "Phase",
+                                                           "Phase",
+                                                           -1,
+                                                           G_MAXINT,
+                                                           -1,
+                                                           G_PARAM_READWRITE));
+        g_object_class_install_property (object_class,
+                                         PROP_ID,
+                                         g_param_spec_string ("id",
+                                                              "ID",
+                                                              "ID",
+                                                              NULL,
+                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+        g_object_class_install_property (object_class,
+                                         PROP_STARTUP_ID,
+                                         g_param_spec_string ("startup-id",
+                                                              "startup ID",
+                                                              "Session management startup ID",
+                                                              NULL,
+                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
 
         g_object_class_install_property (object_class,
-                                         PROP_INNER,
-                                         g_param_spec_object ("inner",
-                                                              "Inner",
-                                                              "Inner",
-                                                              G_TYPE_DESKTOP_APP_INFO,
-                                                              G_PARAM_READWRITE | G_PARAM_CONSTRUCT_ONLY));
+                                         PROP_REGISTERED,
+                                         g_param_spec_boolean ("registered",
+                                                               "Registered",
+                                                               "Registered",
+                                                               FALSE,
+                                                               G_PARAM_READWRITE));
+
+        signals[EXITED] =
+                g_signal_new ("exited",
+                              G_OBJECT_CLASS_TYPE (object_class),
+                              G_SIGNAL_RUN_LAST,
+                              G_STRUCT_OFFSET (GsmAppClass, exited),
+                              NULL, NULL, NULL,
+                              G_TYPE_NONE,
+                              1, G_TYPE_UCHAR);
+        signals[DIED] =
+                g_signal_new ("died",
+                              G_OBJECT_CLASS_TYPE (object_class),
+                              G_SIGNAL_RUN_LAST,
+                              G_STRUCT_OFFSET (GsmAppClass, died),
+                              NULL, NULL, NULL,
+                              G_TYPE_NONE,
+                              1, G_TYPE_INT);
+}
+
+const char *
+gsm_app_peek_id (GsmApp *app)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+
+        return priv->id;
 }
 
 const char *
 gsm_app_peek_app_id (GsmApp *app)
 {
-        g_return_val_if_fail (GSM_IS_APP (app), NULL);
+        return GSM_APP_GET_CLASS (app)->impl_get_app_id (app);
+}
+
+const char *
+gsm_app_peek_startup_id (GsmApp *app)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
 
-        return g_app_info_get_id (G_APP_INFO (app->inner));
+        return priv->startup_id;
+}
+
+/**
+ * gsm_app_peek_phase:
+ * @app: a %GsmApp
+ *
+ * Returns @app's startup phase.
+ *
+ * Return value: @app's startup phase
+ **/
+GsmManagerPhase
+gsm_app_peek_phase (GsmApp *app)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+
+        g_return_val_if_fail (GSM_IS_APP (app), GSM_MANAGER_PHASE_APPLICATION);
+
+        return priv->phase;
 }
 
 gboolean
@@ -155,146 +423,171 @@ gsm_app_peek_is_disabled (GsmApp *app)
 {
         g_return_val_if_fail (GSM_IS_APP (app), FALSE);
 
-        /* GSM_AUTOSTART_APP_ENABLED_KEY key, used by old gnome-session */
-        if (g_desktop_app_info_has_key (app->inner, GSM_APP_ENABLED_KEY) &&
-            !g_desktop_app_info_get_boolean (app->inner, GSM_APP_ENABLED_KEY)) {
-                g_debug ("App %s is disabled by " GSM_APP_ENABLED_KEY,
-                         gsm_app_peek_app_id (app));
-                return TRUE;
+        if (GSM_APP_GET_CLASS (app)->impl_is_disabled) {
+                return GSM_APP_GET_CLASS (app)->impl_is_disabled (app);
+        } else {
+                return FALSE;
         }
+}
 
-        /* Hidden key, used by fdo Desktop Entry spec */
-        if (g_desktop_app_info_get_is_hidden (app->inner)) {
-                g_debug ("App %s is disabled by Hidden",
-                         gsm_app_peek_app_id (app));
-                return TRUE;
-        }
+gboolean
+gsm_app_peek_is_conditionally_disabled (GsmApp *app)
+{
+        g_return_val_if_fail (GSM_IS_APP (app), FALSE);
 
-        /* Check OnlyShowIn/NotShowIn/TryExec */
-        if (!g_desktop_app_info_get_show_in (app->inner, NULL)) {
-                g_debug ("App %s is not for the current desktop",
-                         gsm_app_peek_app_id (app));
-                return TRUE;
+        if (GSM_APP_GET_CLASS (app)->impl_is_conditionally_disabled) {
+                return GSM_APP_GET_CLASS (app)->impl_is_conditionally_disabled (app);
+        } else {
+                return FALSE;
         }
+}
 
-        /* Check if app is systemd enabled */
-        if (g_desktop_app_info_get_boolean (app->inner, GSM_APP_SYSTEMD_HIDDEN_KEY)) {
-                g_debug ("App %s is disabled by " GSM_APP_SYSTEMD_HIDDEN_KEY,
-                         gsm_app_peek_app_id (app));
-                return TRUE;
-        }
-        if (g_desktop_app_info_get_boolean (app->inner, GSM_APP_SYSTEMD_SKIP_KEY)) {
-                g_debug ("App %s is disabled by " GSM_APP_SYSTEMD_SKIP_KEY,
-                         gsm_app_peek_app_id (app));
-                return TRUE;
+gboolean
+gsm_app_is_running (GsmApp *app)
+{
+        g_return_val_if_fail (GSM_IS_APP (app), FALSE);
+
+        if (GSM_APP_GET_CLASS (app)->impl_is_running) {
+                return GSM_APP_GET_CLASS (app)->impl_is_running (app);
+        } else {
+                return FALSE;
         }
+}
+
+gboolean
+gsm_app_peek_autorestart (GsmApp *app)
+{
+        g_return_val_if_fail (GSM_IS_APP (app), FALSE);
 
-        return FALSE;
+        if (GSM_APP_GET_CLASS (app)->impl_get_autorestart) {
+                return GSM_APP_GET_CLASS (app)->impl_get_autorestart (app);
+        } else {
+                return FALSE;
+        }
 }
 
-static void
-app_launched (GAppLaunchContext *ctx,
-              GAppInfo          *appinfo,
-              GVariant          *platform_data,
-              gpointer           data)
+gboolean
+gsm_app_provides (GsmApp *app, const char *service)
 {
-        GsmApp *app = data;
+        if (GSM_APP_GET_CLASS (app)->impl_provides) {
+                return GSM_APP_GET_CLASS (app)->impl_provides (app, service);
+        } else {
+                return FALSE;
+        }
+}
 
-        gint pid = 0;
-        g_variant_lookup (platform_data, "pid", "i", &pid);
+char **
+gsm_app_get_provides (GsmApp *app)
+{
+        if (GSM_APP_GET_CLASS (app)->impl_get_provides) {
+                return GSM_APP_GET_CLASS (app)->impl_get_provides (app);
+        } else {
+                return NULL;
+        }
+}
 
-        /* If pid == 0 the application was launched through D-Bus
-         * activation, therefore it's already in its own unit */
-        if (pid == 0)
-                return;
+gboolean
+gsm_app_has_autostart_condition (GsmApp     *app,
+                                 const char *condition)
+{
 
-        /* We are not interested in the result. */
-        gnome_start_systemd_scope (gsm_app_peek_app_id (app),
-                                   pid,
-                                   NULL,
-                                   NULL,
-                                   NULL, NULL, NULL);
+        if (GSM_APP_GET_CLASS (app)->impl_has_autostart_condition) {
+                return GSM_APP_GET_CLASS (app)->impl_has_autostart_condition (app, condition);
+        } else {
+                return FALSE;
+        }
 }
 
 gboolean
 gsm_app_start (GsmApp  *app,
                GError **error)
 {
-        g_autoptr (GAppLaunchContext) ctx = NULL;
-        GError *local_error = NULL;
-        const char * const *variable_denylist;
-        const char * const *child_environment;
-        guint handler;
-        gboolean success;
-
-        g_debug ("GsmApp: starting %s (command=%s)",
-                 gsm_app_peek_app_id (app),
-                 g_app_info_get_commandline (G_APP_INFO (app->inner)));
-
-        ctx = g_app_launch_context_new ();
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
 
-        variable_denylist = gsm_util_get_variable_blacklist ();
-        for (size_t i = 0; variable_denylist[i] != NULL; i++)
-                g_app_launch_context_unsetenv (ctx, variable_denylist[i]);
+        g_debug ("Starting app: %s", priv->id);
+        return GSM_APP_GET_CLASS (app)->impl_start (app, error);
+}
 
-        child_environment = gsm_util_listenv ();
-        for (size_t i = 0; child_environment[i] != NULL; i++) {
-                g_auto (GStrv) split = g_strsplit (child_environment[i], "=", 2);
-                if (split[1] != NULL)
-                        g_app_launch_context_setenv (ctx, split[0], split[1]);
+gboolean
+gsm_app_restart (GsmApp  *app,
+                 GError **error)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+        gint64 current_time;
+        g_debug ("Re-starting app: %s", priv->id);
+
+        current_time = g_get_monotonic_time ();
+        if (priv->last_restart_time > 0
+            && (current_time - priv->last_restart_time) < _GSM_APP_RESPAWN_RATELIMIT_USEC) {
+                g_warning ("App '%s' respawning too quickly", gsm_app_peek_app_id (app));
+                g_set_error (error,
+                             GSM_APP_ERROR,
+                             GSM_APP_ERROR_RESTART_LIMIT,
+                             "Component '%s' crashing too quickly",
+                             gsm_app_peek_app_id (app));
+                return FALSE;
         }
+        priv->last_restart_time = current_time;
 
-        handler = g_signal_connect (ctx, "launched", G_CALLBACK (app_launched), app);
-        success = g_desktop_app_info_launch_uris_as_manager (app->inner,
-                                                             NULL,
-                                                             ctx,
-                                                             G_SPAWN_DO_NOT_REAP_CHILD | G_SPAWN_SEARCH_PATH,
-                                                             NULL, NULL, NULL, NULL,
-                                                             &local_error);
-        if (!success)
-                g_propagate_prefixed_error (error, local_error,
-                                            "Unable to start app (%s): ",
-                                            gsm_app_peek_app_id (app));
+        return GSM_APP_GET_CLASS (app)->impl_restart (app, error);
+}
 
-        g_signal_handler_disconnect (ctx, handler);
+gboolean
+gsm_app_stop (GsmApp  *app,
+              GError **error)
+{
+        return GSM_APP_GET_CLASS (app)->impl_stop (app, error);
+}
+
+void
+gsm_app_exited (GsmApp *app,
+                guchar  exit_code)
+{
+        g_return_if_fail (GSM_IS_APP (app));
 
-        return success;
+        g_signal_emit (app, signals[EXITED], 0, exit_code);
 }
 
-GsmApp *
-gsm_app_new (GDesktopAppInfo  *info,
-             GError          **error)
+void
+gsm_app_died (GsmApp *app,
+              int     signal)
 {
-        g_autofree char *app_phase = NULL;
+        g_return_if_fail (GSM_IS_APP (app));
 
-        g_return_val_if_fail (info != NULL, NULL);
+        g_signal_emit (app, signals[DIED], 0, signal);
+}
 
-        app_phase = g_desktop_app_info_get_string (info, GSM_APP_PHASE_KEY);
-        if (app_phase && strcmp (app_phase, "Application") != 0) {
-                g_set_error (error, G_IO_ERROR, G_IO_ERROR_FAILED,
-                             "App %s sets " GSM_APP_PHASE_KEY ", but gnome-session no longer manages session services",
-                             g_app_info_get_id (G_APP_INFO(info)));
-                return NULL;
-        }
+gboolean
+gsm_app_get_registered (GsmApp *app)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
+
+        g_return_val_if_fail (GSM_IS_APP (app), FALSE);
 
-        return g_object_new (GSM_TYPE_APP, "inner", info, NULL);
+        return priv->registered;
 }
 
-GsmApp *
-gsm_app_new_for_path (const char  *path,
-                      GError     **error)
+void
+gsm_app_set_registered (GsmApp   *app,
+                        gboolean  registered)
 {
-        g_autoptr (GDesktopAppInfo) info = NULL;
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
 
-        g_return_val_if_fail (path != NULL, NULL);
+        g_return_if_fail (GSM_IS_APP (app));
 
-        info = g_desktop_app_info_new_from_filename (path);
-        if (info == NULL) {
-                g_set_error (error, G_IO_ERROR, G_IO_ERROR_FAILED,
-                             "Desktop file %s couldn't be parsed, or references a missing TryExec binary",
-                             path);
-                return NULL;
+        if (priv->registered != registered) {
+                priv->registered = registered;
+                g_object_notify (G_OBJECT (app), "registered");
         }
+}
+
+gboolean
+gsm_app_save_to_keyfile (GsmApp    *app,
+                         GKeyFile  *keyfile,
+                         GError   **error)
+{
+        GsmAppPrivate *priv = gsm_app_get_instance_private (app);
 
-        return gsm_app_new (info, error);
+        g_debug ("Saving app: %s", priv->id);
+        return GSM_APP_GET_CLASS (app)->impl_save_to_keyfile (app, keyfile, error);
 }
diff --git a/gnome-session/gsm-app.h b/gnome-session/gsm-app.h
index a3099709..765a70da 100644
--- a/gnome-session/gsm-app.h
+++ b/gnome-session/gsm-app.h
@@ -21,27 +21,98 @@
 #define __GSM_APP_H__
 
 #include <glib-object.h>
-#include <gio/gdesktopappinfo.h>
 #include <sys/types.h>
 
+
 #include "gsm-manager.h"
 #include "gsm-client.h"
 
 G_BEGIN_DECLS
 
-#define GSM_TYPE_APP (gsm_app_get_type ())
-G_DECLARE_FINAL_TYPE (GsmApp, gsm_app, GSM, APP, GObject)
+#define GSM_TYPE_APP            (gsm_app_get_type ())
+G_DECLARE_DERIVABLE_TYPE (GsmApp, gsm_app, GSM, APP, GObject)
+
+struct _GsmAppClass
+{
+        GObjectClass parent_class;
+
+        /* signals */
+        void        (*exited)       (GsmApp *app,
+                                     guchar  exit_code);
+        void        (*died)         (GsmApp *app,
+                                     int     signal);
+
+        /* virtual methods */
+        gboolean    (*impl_start)                     (GsmApp     *app,
+                                                       GError    **error);
+        gboolean    (*impl_restart)                   (GsmApp     *app,
+                                                       GError    **error);
+        gboolean    (*impl_stop)                      (GsmApp     *app,
+                                                       GError    **error);
+        gboolean    (*impl_provides)                  (GsmApp     *app,
+                                                       const char *service);
+        char **     (*impl_get_provides)              (GsmApp     *app);
+        gboolean    (*impl_has_autostart_condition)   (GsmApp     *app,
+                                                       const char *service);
+        gboolean    (*impl_is_running)                (GsmApp     *app);
+
+        gboolean    (*impl_get_autorestart)           (GsmApp     *app);
+        const char *(*impl_get_app_id)                (GsmApp     *app);
+        gboolean    (*impl_is_disabled)               (GsmApp     *app);
+        gboolean    (*impl_is_conditionally_disabled) (GsmApp     *app);
+
+        gboolean    (*impl_save_to_keyfile)           (GsmApp     *app,
+                                                       GKeyFile   *keyfile,
+                                                       GError    **error);
+};
+
+typedef enum
+{
+        GSM_APP_ERROR_GENERAL = 0,
+        GSM_APP_ERROR_RESTART_LIMIT,
+        GSM_APP_ERROR_START,
+        GSM_APP_ERROR_STOP,
+        GSM_APP_NUM_ERRORS
+} GsmAppError;
+
+#define GSM_APP_ERROR gsm_app_error_quark ()
 
-GsmApp          *gsm_app_new                            (GDesktopAppInfo  *info,
-                                                         GError          **error);
-GsmApp          *gsm_app_new_for_path                   (const char  *path,
-                                                         GError     **error);
+GQuark           gsm_app_error_quark                    (void);
+
+gboolean         gsm_app_peek_autorestart               (GsmApp     *app);
+
+const char      *gsm_app_peek_id                        (GsmApp     *app);
 const char      *gsm_app_peek_app_id                    (GsmApp     *app);
+const char      *gsm_app_peek_startup_id                (GsmApp     *app);
 GsmManagerPhase  gsm_app_peek_phase                     (GsmApp     *app);
 gboolean         gsm_app_peek_is_disabled               (GsmApp     *app);
+gboolean         gsm_app_peek_is_conditionally_disabled (GsmApp     *app);
 
 gboolean         gsm_app_start                          (GsmApp     *app,
                                                          GError    **error);
+gboolean         gsm_app_restart                        (GsmApp     *app,
+                                                         GError    **error);
+gboolean         gsm_app_stop                           (GsmApp     *app,
+                                                         GError    **error);
+gboolean         gsm_app_is_running                     (GsmApp     *app);
+
+void             gsm_app_exited                         (GsmApp     *app,
+                                                         guchar      exit_code);
+void             gsm_app_died                           (GsmApp     *app,
+                                                         int         signal);
+
+gboolean         gsm_app_provides                       (GsmApp     *app,
+                                                         const char *service);
+char           **gsm_app_get_provides                   (GsmApp     *app);
+gboolean         gsm_app_has_autostart_condition        (GsmApp     *app,
+                                                         const char *condition);
+gboolean         gsm_app_get_registered                 (GsmApp     *app);
+void             gsm_app_set_registered                 (GsmApp     *app,
+                                                         gboolean  registered);
+
+gboolean         gsm_app_save_to_keyfile                (GsmApp    *app,
+                                                         GKeyFile  *keyfile,
+                                                         GError   **error);
 
 G_END_DECLS
 
